import Drawnings.DrawningAirbus;
import Generics.AirbusGenericCollection;
import Generics.AirbusGenericStorage;
import MovementStrategy.DrawningObjectAirbus;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedList;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class FormAirbusCollection extends JFrame {

    private Canvas canvas;
    private AirbusGenericStorage _storage;

    static int pictureBoxWidth = 650;
    static int pictureBoxHeight = 460;
    private JButton buttonGenerateAirbus;
    private JButton buttonUpdate;
    private JButton buttonAddAirbus;
    private JButton buttonDeleteAirbus;

    // работа с наборами
    private JButton buttonAddStorage;
    private JButton buttonDeleteStorage;
    private JButton buttonGetDeleted;
    private JTextField textFieldStorage;
    private JList<String> listStorage;
    private DefaultListModel<String> listModel;
    LinkedList<DrawningAirbus> linkedListDeleted;

    private JTextField textFieldNumber;

    private AirbusGenericCollection<DrawningAirbus, DrawningObjectAirbus> _airbus;

    FormAirbusCollection() {
        listModel = new DefaultListModel<String>();
        listStorage = new JList<String>(listModel);
        _airbus = new AirbusGenericCollection<DrawningAirbus, DrawningObjectAirbus> (pictureBoxWidth, pictureBoxHeight);
        _storage = new AirbusGenericStorage(pictureBoxWidth, pictureBoxHeight);
        linkedListDeleted = new LinkedList<DrawningAirbus>();
        canvas = new Canvas();

        JFrame frame = new JFrame("Коллекция аэробусов");

        buttonAddStorage = new JButton("Добавить набор");
        buttonAddStorage.setMargin(new Insets(0, 0, 0, 0));
        buttonDeleteStorage = new JButton("Удалить набор");
        buttonDeleteStorage.setMargin(new Insets(0, 0, 0, 0));
        buttonAddAirbus = new JButton("Добавить аэробус");
        buttonAddAirbus.setMargin(new Insets(0, 0, 0, 0));
        buttonDeleteAirbus = new JButton("Удалить аэробус");
        buttonDeleteAirbus.setMargin(new Insets(0, 0, 0, 0));
        buttonUpdate = new JButton("Обновить");
        buttonUpdate.setMargin(new Insets(0, 0, 0, 0));
        buttonGetDeleted = new JButton("Загрузить удалёнки");
        buttonGetDeleted.setMargin(new Insets(0, 0, 0, 0));
        buttonGenerateAirbus = new JButton("Форма генерации");
        buttonGenerateAirbus.setMargin(new Insets(0,0,0,0));

        textFieldStorage = new JTextField();
        textFieldNumber = new JTextField();

        setSize(800,500);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(null);

        textFieldStorage.setBounds(pictureBoxWidth, 20, 120, 25);
        buttonAddStorage.setBounds(pictureBoxWidth, textFieldStorage.getY()+30, 120, 25);
        listStorage.setBounds(pictureBoxWidth, buttonAddStorage.getY()+30, 120, 120);
        buttonDeleteStorage.setBounds(pictureBoxWidth, listStorage.getY()+125, 120, 25);
        buttonAddAirbus.setBounds(pictureBoxWidth, buttonDeleteStorage.getY()+30, 120, 25);
        textFieldNumber.setBounds(pictureBoxWidth, buttonAddAirbus.getY()+30, 120, 25);
        buttonDeleteAirbus.setBounds(pictureBoxWidth, textFieldNumber.getY()+30, 120, 25);
        buttonUpdate.setBounds(pictureBoxWidth, buttonDeleteAirbus.getY()+30, 120, 25);
        buttonGetDeleted.setBounds(pictureBoxWidth, buttonUpdate.getY()+30, 120, 25);
        buttonGenerateAirbus.setBounds(pictureBoxWidth, buttonGetDeleted.getY()+30, 120, 25);
        canvas.setBounds(0,0,pictureBoxWidth, pictureBoxHeight);

        add(canvas);
        add(buttonAddStorage);
        add(listStorage);
        add(textFieldStorage);
        add(buttonDeleteStorage);
        add(buttonAddAirbus);
        add(buttonDeleteAirbus);
        add(buttonUpdate);
        add(buttonGenerateAirbus);
        add(buttonGetDeleted);
        add(textFieldNumber);
        setVisible(true);

        // логика формы
        buttonAddStorage.addActionListener(AddStorageListener);
        buttonDeleteStorage.addActionListener(DeleteStorageListener);
        buttonGetDeleted.addActionListener(GetDeletedListener);
        listStorage.addListSelectionListener(listSelectionListener);

        buttonAddAirbus.addActionListener(AddAirbusListener);
        buttonDeleteAirbus.addActionListener(DeleteAirbusListener);
        buttonUpdate.addActionListener(UpdateAirbusListener);
        buttonGenerateAirbus.addActionListener(OpenGenerationForm);
    }

    // секция работы с наборами
    private void ReloadObject()
    {
        int index = listStorage.getSelectedIndex();
        listModel.clear();
        for (int i = 0; i < _storage.Keys().size(); i++)
        {
            listModel.addElement(_storage.Keys().get(i));
        }
        if (listModel.size() > 0 && (index == -1 || index >= listModel.size()))
        {
            listStorage.setSelectedIndex(0);
        }
        else if (listModel.size() > 0 && index > -1 && index < listModel.size())
        {
            listStorage.setSelectedIndex(index);
        }
    }

    // добавить набор
    ActionListener AddStorageListener = new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
            if (textFieldStorage.getText().length() == 0)
            {
                JOptionPane.showMessageDialog(null, "Не все данные заполнены", "Информация", JOptionPane.INFORMATION_MESSAGE);
                return;
            }
            _storage.AddSet(textFieldStorage.getText());
            ReloadObject();
        }
    };

    // выбрать
    ListSelectionListener listSelectionListener = new ListSelectionListener() {
        // public т.к. в интерфейсе метод тоже public
        public void valueChanged(ListSelectionEvent e) {
            canvas.repaint();
        }
    };

    // удалить набор
    ActionListener DeleteStorageListener = new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
            if (listStorage.getSelectedIndex() == -1)
                return;

            if (JOptionPane.showOptionDialog(null, "Удалить " + listStorage.getSelectedValue() + "?", "Удаление", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, new Object[] { "Да", "Нет"}, "Да")
                    == JOptionPane.NO_OPTION)
                return;

            _storage.DelSet(listStorage.getSelectedValue());
            ReloadObject();
        }
    };

    // загрузить удалёнки
    ActionListener GetDeletedListener = new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
            if (linkedListDeleted.size() == 0)
            {
                JOptionPane.showMessageDialog(null, "Нет удалённых аэробусов", "Информация", JOptionPane.INFORMATION_MESSAGE);
                return;
            }

            FormAirbus form = new FormAirbus();
            form._drawningAirbus = linkedListDeleted.getLast();
            linkedListDeleted.removeLast();
            canvas.repaint();
        }
    };
    // конец секции работы с наборами

    ActionListener OpenGenerationForm = new ActionListener()
    {
        @Override
        public void actionPerformed(ActionEvent e) {
            FormGenerationAirbus form = new FormGenerationAirbus();
            dispose();
        }
    };

    // добавить аэробус в набор
    ActionListener AddAirbusListener = new ActionListener()
    {
        @Override
        public void actionPerformed(ActionEvent e) {

            if (listStorage.getSelectedIndex() == -1)
                return;

            var obj = _storage.get(listStorage.getSelectedValue());
            if (obj == null)
                return;

            // выбор аэробуса на второй форме
            FormAirbus form = new FormAirbus();
            form.buttonSelectAirbus.addActionListener(
                new ActionListener() {
                    @Override
                    public void actionPerformed(ActionEvent e) {

                        DrawningAirbus selectedAirbus = form._drawningAirbus;
                        form.dispose();
                        if (selectedAirbus != null) {
                            if (obj.Add(selectedAirbus) != -1) {
                                JOptionPane.showMessageDialog(null, "Объект добавлен");
                                canvas.repaint();
                            } else {
                                JOptionPane.showMessageDialog(null, "Не удалось добавить объект", "Ошибка", JOptionPane.ERROR_MESSAGE);
                                canvas.repaint();
                            }
                        }
                    }
                }
            );
        }
    };

    // удалить аэробус
    ActionListener DeleteAirbusListener = new ActionListener()
    {
        @Override
        public void actionPerformed(ActionEvent e) {

            if (listStorage.getSelectedIndex() == -1)
                return;

            var obj = _storage.get(listStorage.getSelectedValue());
            if (obj == null)
                return;

            Object[] options= {"да", "нет"};
            if (JOptionPane.showOptionDialog(null, "Удалить объект?", "Удаление", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, new Object[] { "Да", "Нет"}, "Да")
                    == JOptionPane.NO_OPTION)
                return;

            try {
                int pos = Integer.parseInt(textFieldNumber.getText());
                // запоминаем удалёнку
                DrawningAirbus deleted = obj.GetT(pos);
                if (obj.Remove(pos)) {
                    // добавить в список удалёнок
                    linkedListDeleted.add(deleted);
                    JOptionPane.showMessageDialog(null, "Объект удален", "Информация", JOptionPane.INFORMATION_MESSAGE);
                    canvas.repaint();
                }
                else
                {
                    JOptionPane.showMessageDialog(null, "Не удалось удалить объект", "Информация", JOptionPane.INFORMATION_MESSAGE);
                }
            }
            catch (Exception ex)
            {
                JOptionPane.showMessageDialog(null, "Не удалось удалить объект", "Информация", JOptionPane.INFORMATION_MESSAGE);
                return;
            }
        }
    };

    // обновить
    ActionListener UpdateAirbusListener = new ActionListener()
    {
        @Override
        public void actionPerformed(ActionEvent e) {
            canvas.repaint();
        }
    };

    class Canvas extends JComponent {
        public Canvas() {}

        public void paintComponent(Graphics g) {
            super.paintComponents(g);

            if (listStorage.getSelectedIndex() == -1)
                return;

            var obj = _storage.get(listStorage.getSelectedValue());

            if (obj == null)
                return;

            if (obj.ShowAirbus() != null)
                g.drawImage(obj.ShowAirbus(), 0, 0, this);

            super.repaint();
        }
    }
}