package Generics;

import Drawnings.DrawningAirbus;
import MovementStrategy.DrawningObjectAirbus;
import java.util.HashMap;
import java.util.List;

public class AirbusGenericStorage {
    HashMap <String, AirbusGenericCollection<DrawningAirbus, DrawningObjectAirbus>> _airbusStorages;
    public List<String> Keys() {
        return _airbusStorages.keySet().stream().toList();
    }
    private int _pictureWidth;
    private int _pictureHeight;

    public AirbusGenericStorage(int pictureWidth, int pictureHeight)
    {
        _airbusStorages = new HashMap<String, AirbusGenericCollection<DrawningAirbus, DrawningObjectAirbus>> ();
        _pictureWidth = pictureWidth;
        _pictureHeight = pictureHeight;
    }

    public void AddSet(String name)
    {
        if (_airbusStorages.containsKey(name))
            // уже занят
            return;
        _airbusStorages.put(name, new AirbusGenericCollection<DrawningAirbus, DrawningObjectAirbus>(_pictureWidth, _pictureHeight));
    }

    public void DelSet(String name)
    {
        if (!_airbusStorages.containsKey(name))
            return;
        _airbusStorages.remove(name);
    }

    // Доступ к набору
    public AirbusGenericCollection<DrawningAirbus, DrawningObjectAirbus> get(String ind)
    {
        if (_airbusStorages.containsKey(ind))
            return _airbusStorages.get(ind);
        return null;
    }

    // вызов удалёнок
    public DrawningObjectAirbus get(String iStorage, int iAirbus){
        if (!_airbusStorages.containsKey(iStorage))
            return null;
        return _airbusStorages.get(iStorage).GetU(iAirbus);
    }
}